Categories:
  - Connectivity
License: GPL-3.0-only
AuthorName: Mikhail Basov
AuthorEmail: lws@basov.net
SourceCode: https://github.com/mvbasov/lWS
IssueTracker: https://github.com/mvbasov/lWS/issues
Changelog: https://github.com/mvbasov/lWS/releases

AutoName: lWS
Description: |-
    '''It is ...'''

    * ... a Web Server for static content.
    * ... lightweight. APK size less then 100 Kb.
    * ... as simple as possible. Only essential features implemented.
    * ... open. [https://github.com/mvbasov/lWS Source code] released under GPL-3.0.
    * ... a personal solution. It is not optimized/tested for many parallel connections and large file transfer.
    * ... network state responsive. Requires Wi-Fi connected or tethering enabled. Service will stop automatically if network is disconnected.

    '''Based on'''

    This application continues the development of
    [https://github.com/bodeme/androidwebserver Webserver for Android].

    '''What is configurable'''

    * Document root. Path may be entered as text or optionally selected using https://f-droid.org/packages/org.openintents.filemanager. If it is not installed it will offered for install.
    * Port. May be between 1024 and 65535. Default is 8080

    Any wrong values in parameters will automatically be set back to their defaults.

    '''Document root'''

    Document root by default is set to application private directory, example index
    file automatically created. It is a safe configuration. You can place your pages
    in this directory. But be careful! If you use Android 5.0 or above and uninstall
    the application this directory and its content will be removed.

    '''Security warning'''

    You can change document root to any readable path on file system, but you need
    to understand what are you doing. __Be careful: you could (suddenly?) create the
    configuration so than anyone on the same Wi-Fi network could access the data on
    your device whether you like it or not.__ All files from document root and below
    are available for reading without any restrictions to anyone who's connected to
    the network and knows the URL of the server.

    '''"Send", "QR code" and "Browser"'''

    After server starts you can press:

    * "Browser" button for check server operation in your local browser
    * "QR code" to call https://f-droid.org/packages/net.basov.lws.qr.fdroid or https://f-droid.org/packages/com.google.zxing.client.android to share URL by QR code. If no app is installed it offers to install lWS QR plugin
    * "Send" to share the working server URL to another device via Bluetooth, Android Beam, E-Mail and any other way available on your device.

    '''On screen log'''

    The application has no permanent logging. This was treated this as redundant
    functionality. The app tries to have the notification up to date. The on screen
    log works only when the application is visible. Log screen may be cleared after
    returning from background.

RepoType: git
Repo: https://github.com/mvbasov/lWS

Builds:
  - versionName: 03.00.01
    versionCode: 30001
    commit: v03.00.01f
    subdir: app
    patch:
      - gradle_pkgid.patch
      - strings_lws_qr_package_name.patch
    gradle:
      - yes
    prebuild: sed -i -e '/applicationIdSuffix/d' -e '/versionNameSuffix/d' build.gradle

  - versionName: 05.00.00
    versionCode: 50000
    commit: v05.00.00
    subdir: app
    gradle:
      - yes
    prebuild:
      - sed -i -e '/applicationIdSuffix/d' -e '/versionNameSuffix/d' -e 's/net.basov.lws/net.basov.lws.fdroid/'
        build.gradle
      - sed -i -e 's/net.basov.lws.qr.gpm/net.basov.lws.qr.fdroid/' src/main/res/values/strings.xml

  - versionName: 06.00.00
    versionCode: 60000
    commit: v06.00.00f
    subdir: app
    gradle:
      - yes
    prebuild:
      - sed -i -e '/applicationIdSuffix/d' -e '/versionNameSuffix/d' -e 's/net.basov.lws/net.basov.lws.fdroid/'
        build.gradle
      - sed -i -e 's/net.basov.lws.qr.gpm/net.basov.lws.qr.fdroid/' src/main/res/values/strings.xml

  - versionName: 07.00.00
    versionCode: 70000
    commit: v07.00.00f
    subdir: app
    gradle:
      - yes
    prebuild:
      - sed -i -e '/applicationIdSuffix/d' -e '/versionNameSuffix/d' -e 's/net.basov.lws/net.basov.lws.fdroid/'
        build.gradle
      - sed -i -e 's/net.basov.lws.qr.gpm/net.basov.lws.qr.fdroid/' src/main/res/values/strings.xml

AutoUpdateMode: Version v%vf
UpdateCheckMode: Tags v\d+\.00(\.\d+)?f
UpdateCheckName: net.basov.lws
CurrentVersion: 07.00.00
CurrentVersionCode: 70000
